var presets = new Array();

function loadSetts()
{
//	loadDefaults(); 
	
	var numPairs = 0;
	try
	{
		numPairs = getNumPairs();
	}
	catch(err) // settings aren't there. get defs
	{
		loadDefaults(); 
		numPairs = getNumPairs();
	}

	for (var x=0; x<numPairs; x++)
	{
		var outArr = loadRecodePair(x);
	
		presets.push(outArr);
	}
	
	buildList();
	document.getElementById("lang_list").selectedIndex=0;
}

function buildList()
{
	var lbox = document.getElementById("lang_list");
	
	var selPos = lbox.selectedIndex;
	
	while (lbox.getRowCount() > 0)
		lbox.removeItemAt(0);
	
	var x;
	for (x=0; x<presets.length; x++)
	{
		var item = document.createElement('listitem');
		item.setAttribute('label', presets[x].strName);
		item.setAttribute('value', x);
		item.setAttribute('type', 'checkbox');
		item.setAttribute('checked', presets[x].checked);
		lbox.appendChild(item);
	}
	
	lbox.selectedIndex = selPos < x ? selPos : 0;
	lbox.focus();
}

function getNumPairs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("urlcorrector.");
	return prefs.getIntPref("numPairs");
}
			
function saveNewPreset()
{
	var lbox = document.getElementById("lang_list");
	if (lbox.selectedIndex == -1)
		return;
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var sName = new Object();
	sName.value = "<Type new recode set's name here>";
	var outer = new Object();
	outer.value = "";
	if (promptService.prompt(window, "New recode set", "Enter name for the new recode table.", sName, null, outer))
	{
//		var idx = getNumPairs();
//		if (sName == lbox.selectedItem.label)
//			idx = lbox.selectedIndex;
		
		var preset = {};
		preset.strName = sName.value;
		preset.checked = true;
	
		preset.strFrom = ""; 
		preset.strTo = ""; 
		presets[presets.length] = preset;
	}
	
	buildList();
}

function delSel()
{
	var lbox = document.getElementById("lang_list");
	if (lbox.selectedIndex == -1)
		return;
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	if (!promptService.confirm(window, "Confirm deletion", "Are you sure you want to delete recode table: "+lbox.selectedItem.label+"?"))
		return;
	
	presets.splice(lbox.selectedIndex, 1);
	
	buildList();	
}

function selChanged()
{
	var lbox = document.getElementById("lang_list");
	if (lbox.selectedIndex == -1)
		return;

	document.getElementById("chars_to_replace").value = presets[lbox.selectedIndex].strFrom;
	document.getElementById("chars_to_replace_with").value = presets[lbox.selectedIndex].strTo;
}

function updatePreset()
{
	var lbox = document.getElementById("lang_list");
	if (lbox.selectedIndex == -1)
		return;

	presets[lbox.selectedIndex].strFrom = document.getElementById("chars_to_replace").value;
	presets[lbox.selectedIndex].strTo = document.getElementById("chars_to_replace_with").value;
}

function listClicked(e)
{
	var lbox = document.getElementById("lang_list");
	if (e.clientX > 50) // hack for checkbox::tbf?
			lbox.selectedItem.checked = !lbox.selectedItem.checked;
	
	presets[lbox.selectedIndex].checked = lbox.selectedItem.checked;
}

function saveSetts()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("urlcorrector.");
	prefs.deleteBranch("");
	
	for (var x=0; x<presets.length; x++)
		saveRecodePair(x, presets[x].strName, presets[x].checked, presets[x].strFrom, presets[x].strTo);
}

function moveSel(up)
{
	var lbox = document.getElementById("lang_list");

	var idx = lbox.selectedIndex;
	
	if ((up && idx>0) || (!up && idx < presets.length-1))
	{
		var preset = presets[idx];
		presets.splice(idx, 1);
		idx = up ? idx-1 : idx+1;
		urlCorrectDumpObject(preset);
		presets.splice(idx, 0, preset);
		
		lbox.selectedIndex = idx;
	}
	
	buildList();
}